#!pathtoperl
use strict;
use CGI::Carp 'fatalsToBrowser';
use CGI;
require "./functions.cgi";

my $db = connecttodatabase();

my $approved = isLoggedin();
my $isadmin = isLoggedinAdmin();
my $isloggedin = isLoggedin();
my $user= hasCookie();

print_html("headers");
 
print '<html>';

print '<head>';
print '<meta http-equiv="Content-Type" content="text/css; charset=iso-8859-1">';
print_html("stylesheet");

#Gets course information
my %res = getCourseInfo();
my $coursename = $res{coursename};

print "<title>$coursename Discussion Board </title>";
print '</head>';

print '<body>';
print_html("javascriptvalidation");

print "<table width=100%><tr>";

#If the user is not logged in display that in the upper right corner
#Along with a login button link
if(!$isloggedin){

    print "<td align=right>You are not logged in<br>";
    print "<a href=\"login.cgi?page=discussion.cgi\">Click here to Login</a></td>";

}
#If the user is logged in print their username
else {
    my $username = getUsername($user);
    print "<td align=right>$username logged in </td>";
}
print "</tr></table>";
print '<div align=center>';

print "<h1>$coursename Discussion Board</h1> </center>";

print '<br><br>';
print '<div align=center>';
print '<table border = 1 width = 80% cellpadding=5 cellspacing=0>';


print '<tr>';
#If an admin is logged in display the admin header (for archive and delete)
if ($isadmin){
    print "<th colspan=2 class=\"blue\" width=35%>Admin Features</th>";
}
print "<th class=\"blue\"> Topics </th><th class=\"blue\" width=7%># Posts</th><th class=\"blue\" width=13% ># New Posts </th></tr>";

#Gets the database topics and prints them in an html table
my $topicsresult = $db->query("select * from D_B_Topics");
while(my %topic = $topicsresult->FetchHash){
    #The topic id number
    my $topicid = $topic{topicid};

    #The topic name
    my $topicname = $topic{topicname};

    #Whether or not the topic is archived
    my $isarchived = $topic{isarchived};

    #Used to determine if a field should be displayed (it may be archived)
    my $display = 1;
    
    #Used to keep track of the number of new posts
    my $newposts = 0;

    #If the user is approved
    if($approved){
	#Gets all the top level threads
	my $threadsres = $db->query("select * from D_B_Posts where topicid=$topicid and isreplyto=0");
	while(my %threadhash = $threadsres->FetchHash){
	    
	    #need to find out which posts are new.  
	    #To do this first find the last time the user viewed the thread
	    my $viewresult = $db->query("select timeofview from D_B_Views where userid=$user and threadid=$threadhash{threadid}");
	    my $timeoflastview;
	    if($timeoflastview = $viewresult->FetchRow){
	    }
	    else {
		$timeoflastview=-1;
	    }
	    
	    if($timeoflastview != -1){ #if the user has viewed the thread subtract the times and count each new post
		
		my $timediff = $db->query("select unix_timestamp('$timeoflastview') - unix_timestamp(timeofpost) from D_B_Posts where threadid=$threadhash{threadid}");
		while(my $td = $timediff->FetchRow){
		    if($td < 0){
			$newposts++;
		    }
		}
	    }
	    else { #if the user hasnt viewed the thread then all posts are new
		    my $tresult = $db->query("select count(postid) from D_B_Posts where threadid=$threadhash{threadid}");
		    $newposts += $tresult->FetchRow;
		    
		}
	    
	}
    }
    #If the user is not logged in then we do not keep track of new posts
    else {
	$newposts = "Not Logged in";
    }
    #If the admin is not logged in and the topic is archived then dont display the topic
    if(!$isadmin){
	if($isarchived){
	    $display = 0;
	}
    }
    #If we are displaying a post
    if($display){
	#If there are newposts and they are approved then highlight the background using class hasnew
	if($newposts && $approved){
	    print "<tr class=\"hasnew\">";

	}
  	#If there are no new posts or they are not approved then highlight the background using class oldnew
	else{
	    print "<tr class=\"nonew\">";
	}
	#If the admin is logged in
	if($isadmin){
	   #If the topic is archived print an unarchive button 
	    if($isarchived){
		print <<HTML;
		
		<form action="archivetopic.cgi" method=post>
		    <input type=hidden name=topic value="$topicid">
		    <input type=hidden name="unarchive" value=1>
		    <td align=center>
		    <input type=submit value="Unarchive this topic" class="standardButton">
		    
		    

HTML

	    }
	    #If the topic is not archived print an archive button
	    else {
		print <<HTML;
		
		<form action="archivetopic.cgi" method=post>
		    <input type=hidden name=topic value="$topicid">
		    <td align=center>
		    <input type=submit class="standardButton"  value="archive this topic">
		    
		

HTML

}
            #Print the deletetopic button
	    print <<HTML;
	    </td></form>
		<form action="deletetopic.cgi" method=post onSubmit="return confirmDelete();">
		<input type=hidden name=topic value="$topicid">
		<td align=center >

		<input type=submit value="delete this topic" class="standardButton">
		</td>
		</form>
		
HTML
       
}
	#Print a link to the thread page
	print "<td>";
	print "<a href=\"threads.cgi?topic=$topicid\">$topicname</a></td>";

	#Gets the number of posts
	my $notresult = $db->query("select count(threadid) from D_B_Posts where topicid = $topicid");
	my $numberofthreads=$notresult->FetchRow;
	
	#Prints the number of threads and the number of newposts to the html page
	print "<td  align=center>$numberofthreads</td>";	
			
	print "<td  align=center>$newposts</td>";
	print "</tr>";
    }
}
print '</table>';
#If the admin is logged in
if($isadmin){
    #Print the start a new topic field and button to the html page
    print "<h1 class=bigger>Start new Topic</h1><br>";
    
    print <<HTML;

 <form action="addnewtopic.cgi" method=post name=addtopic onSubmit="return topicData();">
  <TABLE>
    <TR><TD><input type=text name="topic"></TD></TR>
    <TR><TD align=center><input type= submit name="submit" value="Add Topic"></TD></TR>
  </TABLE>
HTML




}
#Close HTML page
print '</div>';

print '<br><br>';
print '</body>';

print '</html>';

