#!pathtoperl
use strict;
use CGI::Carp 'fatalsToBrowser';
use CGI;
require "./functions.cgi";



my $query;
$query = new CGI; #get the cgi object

my $topic = $query->param("topic");  #find out which topic we are looking at
my $topicname; 
my $user;
my $isadmin = isLoggedinAdmin();

$user = hasCookie(); #the userid or -1


if(!$topic){ #if there was no topic then set topic to -1
    $topic = -1;
}

my $db = connecttodatabase(); #connect to the database

my $approved = isLoggedin(); #find out if the user is logged in


#find out what the topic name is
my $result = $db->query("select * from D_B_Topics where topicid = $topic");
if(my %topichash = $result->FetchHash){
    $topicname = $topichash{topicname};
}

print_html("headers"); #print html headers


#open html 
print '<html><head>'; 

print_html("stylesheet"); #print the stylesheet for the page
print_html("javascriptvalidation");

my %res = getCourseInfo(); #get the courseinfo and subsequently the course name
my $coursename = $res{coursename};

print "<title>$coursename Discussion Board </title></head></body>"; 



if($topicname){ #if the topic was found then print the html
    print "<table width=100%><tr>";

    print "<td><a href=\"discussion.cgi\">Back to Topics</a></td>";

    
    if(!$approved){#checks if the user is logged in and prints status
	print "<td align=right>You are not logged in<br>";
	print "<a href=\"login.cgi?page=threads.cgi?topic=$topic\">Click here to Login</a></td>";
	
    }
    else {
	my $username = getUsername($user);
	print "<td align=right>$username logged in </td>";
    }
    print "</tr></table>"; 
    
    
    print '<div align=center>';#prints the title of topic at center of the page
    print '<br>';
    print "<h1 class=\"bigger\">$topicname</h1>";
    print '<br>';
    print "<br>";

    if($user != -1){#checks if user is logged in, and if they are it displays form to make a thread, otherwise form does not appear
	print "<a href=\"#newthread\" class=\"bigger\">Start a new thread</a>";
    }
    print "<br>";        
    print "<br>";    
    print '<table border = 1 cellpadding=5 cellspacing=0 width = 95%>';
    print "<tr>";

    if($isadmin){#checks if user is admin and if they are it displays admin features 
	print "<th nowrap class=\"blue\">Admin Features</th>";
    }
    print "<th  width = 60% class=\"blue\"> Threads </th><th class=\"blue\" width = 10%> \# Posts </th><th class=\"blue\" width = 15%> \# New Posts </th><th class=\"blue\" width = 35%> Started by: </th> </tr>";
    

    #find the info for the threads contained in the topic
    my $threadresult = $db->query("select * from D_B_Posts where topicid=$topic and isreplyto=0 order by timeofpost desc");
    while(my %thread = $threadresult->FetchHash){ 
	#get the thread information from hash
	my $name = $thread{threadname}; 
	my $userid = $thread{userid};
	my $username =	getUsername($userid);
	my $threadid = $thread{threadid};
	
	my $noposts = $db->query("select count(postid) from D_B_Posts where threadid='$threadid'");
	my $numberofposts = $noposts->FetchRow;
	my $newposts = 0;
	if($approved){#checks if they are logged in
	    
	    #need to find out which posts are new.  
	    #To do this first find the last time the user viewed the thread
	    my $viewresult = $db->query("select timeofview from D_B_Views where userid=$user and threadid=$threadid");
	    my $timeoflastview;
	    if($timeoflastview = $viewresult->FetchRow){
	    }
	    else {
		$timeoflastview=-1;
	    }

	    if($timeoflastview != -1){ #if the user has viewed the thread subtract the times and count each new post
		
		my $timediff = $db->query("select unix_timestamp('$timeoflastview') - unix_timestamp(timeofpost) from D_B_Posts where threadid=$threadid");
		while(my $td = $timediff->FetchRow){
		    if($td < 0){#checks if there are any new posts since the last time the user viewed the thread
			$newposts++;
		    }
		}
	    }
	    else { #if the user hasnt viewed the thread then all posts are new
		my $tresult = $db->query("select count(postid) from D_B_Posts where threadid=$threadid");
		$newposts = $tresult->FetchRow;
		
	    }
	}
	else {#if they are not logged in,makes new post view "Not Logged in"
	    $newposts = "Not Logged in";
	}
	

	#print out thread information
	if($newposts && $approved){
	    print "<tr class=\"hasnew\">";
	}
	else {
	    print "<tr class=\"nonew\">";
	}
	if($isadmin){#if they are a admin display the delete thread button
	    print "<td>";
	    print <<HTML;
	    
	    <form action="deletethread.cgi" onSubmit="return confirmDelete();" method=post>
		<input type=hidden name=thread value="$threadid">
		<input type=submit value="delete this thread">
		</td>
		
HTML
	}
	print "<td></form><a href=\"posts.cgi?threadid=$threadid&topicid=$topic\">$name</a></td><td align=center>$numberofposts</td><td align=center>";
	
	if($approved){
	    print "$newposts";
	}
	else{
	    print "Not Logged in"; #if the user isnt logged in there is no way to tell what posts they have viewed
	}
	
	#if the user chose to be anonymous then set that
	my $isanon = $thread{isanonymous};
	if($isadmin){#if they are an admin they can still see username
	    if($isanon){#if they posted anonymously a * is put next to their username
		$username .= "*";
	    }
	}
	elsif($isanon){#if not a admin they are shown as anonymous
	    $username = "Anonymous";
	}
	
	print "</td><td align=center>$username</td></tr>";
	
	
	
	
    }
    
    
    print '</table>';
    if($isadmin){#tells admin that a * means the user posted anonymously
	print "<br>* User posted anonymously\n";
    }
    print '<br><br>';
    if($approved){ #if the user is logged in give them the option to start a new thread
	#displays a form to make a new thread
	print "<a name=\"newthread\"></a>";
	print "<FORM METHOD=POST ACTION=\"addnewthread.cgi\" name=discussion onSubmit=\"return discussionData();\">";
	print "<input type=hidden name=\"topicid\" value=\"$topic\">";
	print "<table ><tr>\n";
	print "<th colspan=3 class=bigger>Start a new thread</th></tr>";
	print "<tr><td><br></td></tr>";
	print "<tr><td align=right>Thread Title:&nbsp;</td>";
	print "<td colspan=2><input type=text name=\"threadname\" size=40 maxlength=50>";
	print "</td></tr><tr><td align=right>Comments:&nbsp;</td><td colspan=2>";
	print "<textarea name=\"comments\" rows=10 cols=70 wrap=virtual>";
	print "</textarea></td></tr>";
	print "<tr><td align=center>";
	print "Post Anonymously*:&nbsp;</td><td><input type=checkbox name=isanon></td>";
	print "<td align=center><input type=submit VALUE=\"Make New Thread\">";
	print "</tr><tr><td colspan=3 align=center><br>*Note that anonymous posts are not anonymous to the course instructor</td></tr>";  
	print   "</table> </FORM>";
	print '<br><br>';
	print '<br><br>';
	print '<br><br>';
	print '<br><br>';
	print '<br><br>';
	print '<br><br>';
	print '<br><br>';
	print '<br><br>';
	print '<br><br>';
	print '<br><br>';
	print '<br><br>';
	print '<br><br>';
	print '<br><br>';

    }
    print '</div>';
    
    print_html("endhtml");
    
}
else{ #if the threadid was wrong
    print "<table><tr>";
    if(!$approved){#displays if not logged in
	print "<td>You are not logged in</td>";
	print "<td><a href=\"login.cgi?page=discussion.cgi\">Click here to Login</a></td>";
	
    }
    else {#if logged in display username and status
	my $username = getUsername($user);
	print "<td>$username logged in </td>";
    }
#tells user thread id was invalid and gives them a link to go back to topics
    print "<td><a href=\"discussion.cgi\">Back to Topics</a>";
    print "</tr></table>";
    print "<div align=center><h1>Invalid Thread ID</h1><br>";
    print "This most likely means the topic you were viewing has been deleted.";
    print "<br><a href=\"discussion.cgi\">Back to Topics</a>";

    print "</div>";
    print_html("endhtml");
    
    
}
